using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Web;
using System.Web.Security;
using FiltronASP.Helpers.HashExtensions;
using FiltronASP.Models.DAO.Interfaces;
using FiltronASP.Models.DAO;
using FiltronASP.Models;

namespace FiltronASP.Authorization
{
    public class CmsMembershipProvider : MembershipProvider
    {

        #region Unimplemented MembershipProvider methods

        public override string ApplicationName
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public override bool ChangePassword(string username, string oldPassword, string newPassword)
        {
            throw new NotImplementedException();
        }

        public override bool ChangePasswordQuestionAndAnswer(string username, string password, string newPasswordQuestion, string newPasswordAnswer)
        {
            throw new NotImplementedException();
        }

        public override MembershipUser CreateUser(string username, string password, string email, string passwordQuestion, string passwordAnswer, bool isApproved, object providerUserKey, out MembershipCreateStatus status)
        {
            throw new NotImplementedException();
        }

        public override bool DeleteUser(string username, bool deleteAllRelatedData)
        {
            throw new NotImplementedException();
        }

        public override bool EnablePasswordReset
        {
            get { throw new NotImplementedException(); }
        }

        public override bool EnablePasswordRetrieval
        {
            get { throw new NotImplementedException(); }
        }

        public override MembershipUserCollection FindUsersByEmail(string emailToMatch, int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotImplementedException();
        }

        public override MembershipUserCollection FindUsersByName(string usernameToMatch, int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotImplementedException();
        }

        public override MembershipUserCollection GetAllUsers(int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotImplementedException();
        }

        public override int GetNumberOfUsersOnline()
        {
            throw new NotImplementedException();
        }

        public override string GetPassword(string username, string answer)
        {
            throw new NotImplementedException();
        }

        public override MembershipUser GetUser(string username, bool userIsOnline)
        {
            throw new NotImplementedException();
        }

        public override MembershipUser GetUser(object providerUserKey, bool userIsOnline)
        {
            throw new NotImplementedException();
        }

        public override string GetUserNameByEmail(string email)
        {
            throw new NotImplementedException();
        }

        public override int MaxInvalidPasswordAttempts
        {
            get { throw new NotImplementedException(); }
        }

        public override int MinRequiredNonAlphanumericCharacters
        {
            get { throw new NotImplementedException(); }
        }

        public override int MinRequiredPasswordLength
        {
            get { throw new NotImplementedException(); }
        }

        public override int PasswordAttemptWindow
        {
            get { throw new NotImplementedException(); }
        }

        public override MembershipPasswordFormat PasswordFormat
        {
            get { throw new NotImplementedException(); }
        }

        public override string PasswordStrengthRegularExpression
        {
            get { throw new NotImplementedException(); }
        }

        public override bool RequiresQuestionAndAnswer
        {
            get { throw new NotImplementedException(); }
        }

        public override bool RequiresUniqueEmail
        {
            get { throw new NotImplementedException(); }
        }

        public override string ResetPassword(string username, string answer)
        {
            throw new NotImplementedException();
        }

        public override bool UnlockUser(string userName)
        {
            throw new NotImplementedException();
        }

        public override void UpdateUser(MembershipUser user)
        {
            throw new NotImplementedException();
        }

        #endregion

        /// <summary>
        /// klasa do operacji na bazie danych, tabeli uzytkownikow
        /// </summary>
        private IUserDAO _userDAO;

        /// <summary>
        /// Konstruktor (dependency injection).
        /// </summary>
        public CmsMembershipProvider()
            : this(new UserDAO())
        {
        }

        /// <summary>
        /// Konstruktor.
        /// </summary>
        /// <param name="userDAO">klasa do operacji na bazie danych, tabeli uzytkownikow</param>
        public CmsMembershipProvider(IUserDAO userDAO)
        {
            this._userDAO = userDAO;
        }

        /// <summary>
        /// Aktualnie zalogowany uzytkownik.
        /// </summary>
        public User User { get; private set; }

        /// <summary>
        /// Metoda sprawdzajaca poprawnosc loginu i hasla uzytkownika.
        /// </summary>
        /// <param name="userLogin">login</param>
        /// <param name="password">haslo</param>
        /// <returns>true, gdy przejdzie walidacje, false wpp</returns>
        public override bool ValidateUser(string userLogin, string password)
        {
            if ((String.IsNullOrEmpty(password.Trim())) || (String.IsNullOrEmpty(userLogin.Trim())))
            {
                return false;
            }   //if empty
            User user = this._userDAO.FindByUserLogin(userLogin);
            if (user == null)
            {
                return false;
            }   //if null
            string hash = SHA1.Create().ComputeHash(password + user.user_pass_salt).ToBase64();
            if (user.user_pass_hash.Equals(hash))
            {
                this.User = user;
                return true;
            }
            return false;
        }

    }
}
